;=== Defines
!define 32     FolderSizes\FolderSizes.exe
!define 64     FolderSizes64\FolderSizes.exe
!define SET64  `Kernel32::SetEnvironmentVariable(t "FOLDERSIZES", t "FolderSizes64")`
!define SET32  `Kernel32::SetEnvironmentVariable(t "FOLDERSIZES", t "FolderSizes")`
;===
!define REG    `${SET}\${APP}.reg`
!define DEFREG `${DEFDATA}\settings\${APP}.reg`
;===
!define DIR    `${DATA}\AllUsersAppData`
!define DEFDIR `${DEFDATA}\AllUsersAppData`
;===
!define DAT    `${DIR}\genconfig.dat`
!define DEFDAT `${DEFDIR}\genconfig.dat`
;===
!define APPDLL `$EXEDIR\App\$0\FSShellExt.dll`
!define DLL    `$TEMP\FSShellExt.dll`
;===
!define CLSID  `SOFTWARE\Classes\CLSID\{56160A70-D083-4856-9998-F565ABC03F86}\InprocServer32`
;===
!define DOC    `${DATA}\My Documents`
;=== Custom.nsh
${SegmentFile}
${Segment.OnInit}
	Push $0
	${IsWOW64} $0
	StrCmp $0 0 ThirtyTwoBit
	SetRegView 64
	System::Call `${SET64}`
	${DisableX64FSRedirection}
	${WriteSettings} 64 Architecture
		Goto END
	ThirtyTwoBit:
	System::Call `${SET32}`
	${WriteSettings} 32 Architecture
	END:
	Pop $0
!macroend
;===
!macro OS
	${If} ${IsNT}
		${If} ${IsWinXP}
			${IfNot} ${AtLeastServicePack} 2
				MessageBox MB_ICONSTOP|MB_TOPMOST `${PORTABLEAPPNAME} requires Service Pack 2 or newer`
				Call Unload
				Quit
			${EndIf}
		${ElseIfNot} ${AtLeastWinXP}
			MessageBox MB_ICONSTOP|MB_TOPMOST `${PORTABLEAPPNAME} requires Windows XP or newer`
			Call Unload
			Quit
		${EndIf}
	${Else}
		MessageBox MB_ICONSTOP|MB_TOPMOST `${PORTABLEAPPNAME} requires Windows XP or newer`
		Call Unload
		Quit
	${EndIf}
!macroend
;===
!macro Init
	IfFileExists `${DOC}` +2
	CreateDirectory `${DOC}`
	IfFileExists `${REG}` +2
	CopyFiles /SILENT `${DEFREG}` `${REG}`
	IfFileExists `${DAT}` +3
	CreateDirectory `${DIR}`
	CopyFiles /SILENT `${DEFDIR}\*.*` `${DIR}`
!macroend
;===
!macro ProExecInit
	Push $0
	ReadEnvStr $0 FOLDERSIZES
	${If} $0 == FolderSizes64
		${GetParameters} $0
		StrCpy $ProgramExecutable ""
		${If} $0 != ""
		${AndIf} $ProgramExecutable == ""
			${ReadLauncherConfig} $ProgramExecutable Launch ProgramExecutableWhenParameters64
		${EndIf}
		${If} $ProgramExecutable == ""
			StrCpy $ProgramExecutable ${64}
		${EndIf}
	${Else}
		${GetParameters} $0
		StrCpy $ProgramExecutable ""
		${If} $0 != ""
		${AndIf} $ProgramExecutable == ""
			${ReadLauncherConfig} $ProgramExecutable Launch ProgramExecutableWhenParameters
		${EndIf}
		${If} $ProgramExecutable == ""
			StrCpy $ProgramExecutable ${32}
		${EndIf}
	${EndIf}
	Pop $0
!macroend
;===
!macro RunAsAdmin
	Push $0
	${ReadUserConfig} $0 EnableShellExtension
	${If} $0 == true
		StrCpy $RunAsAdmin force
	${ElseIf} $0 == auto
		${If} ${IsAdmin}
			StrCpy $RunAsAdmin force
		${EndIf}
	${EndIf}
	Pop $0
!macroend
;===
!macro PreDLL
	${If} $RunAsAdmin == force
		Push $0
		Push $1
		ClearErrors
		ReadRegStr $0 HKLM `${CLSID}` ""
		${IfNot} ${Errors}
			StrCpy $1 $0 1
			StrCmp $1 `"` 0 +2
			StrCpy $0 $0 "" 1
			StrCpy $1 $0 "" -1
			StrCmp $1 `"` 0 +2
			StrCpy $0 $0 -1
			${WriteRuntimeData} ${PAL} DLL `$0`
			${DLL::UNREG} `$0` /DISABLEFSR
		${EndIf}
		Pop $1
		Pop $0
	${EndIf}
!macroend
;===
!macro PrePrimaryDLL
	${If} $RunAsAdmin == force
		Push $0
		ReadEnvStr $0 FOLDERSIZES
		CopyFiles /SILENT `${APPDLL}` `${DLL}`
		${DLL::REG} `${DLL}` /DISABLEFSR
		Pop $0
	${EndIf}
!macroend
;===
!macro PostPrimaryDLL
	${If} $RunAsAdmin == force
		Push $0
		ReadEnvStr $0 FOLDERSIZES
		${DLL::UNREG} `${DLL}` /DISABLEFSR
		Pop $0
	${EndIf}
!macroend
;===
!macro UnloadDLL
	${If} $RunAsAdmin == force
		Push $0
		ClearErrors
		${ReadRuntimeData} $0 ${PAL} DLL
		${IfNot} ${Errors}
			${DLL::REG} `$0` /DISABLEFSR
		${EndIf}
		${ConfigReadS} `${CONFIG}` DeleteDLLByForce= $0
		${If} $0 == true
			${Close} ${CABW} ""
		${EndIf}
		Delete /REBOOTOK `${DLL}`
		Pop $0
	${EndIf}
!macroend